"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.render = exports.DEFAULT_PORT = void 0;
const ink_1 = require("ink");
const react_fast_compare_1 = __importDefault(require("react-fast-compare"));
const serve_1 = require("./serve");
exports.DEFAULT_PORT = 3000;
function render(tree, options) {
    const port = options?.port || exports.DEFAULT_PORT;
    const wss = (0, serve_1.serve)({ port });
    const defaultWrite = process.stdout.write.bind(process.stdout);
    let prev = '';
    process.stdout.write = (e) => {
        // Skip unnecessary updates.
        if ((0, react_fast_compare_1.default)(prev, e))
            return defaultWrite(e);
        prev = e;
        wss.clients.forEach(client => client.send(e));
        return defaultWrite(e);
    };
    return (0, ink_1.render)(tree, {
        ...options,
        stdout: process.stdout,
        stdin: process.stdin,
        stderr: process.stderr,
    });
}
exports.render = render;
