"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serve = void 0;
const express_1 = __importDefault(require("express"));
const express_ws_1 = __importDefault(require("express-ws"));
const handlebars = __importStar(require("handlebars"));
const fs_1 = __importDefault(require("fs"));
const ip_1 = __importDefault(require("ip"));
const app_root_path_1 = __importDefault(require("app-root-path"));
const serve = ({ port }) => {
    const { app, getWss } = (0, express_ws_1.default)((0, express_1.default)()
        .use(express_1.default.static(app_root_path_1.default.resolve('public')))
        .get('/index.css', (req, res) => res.sendFile(app_root_path_1.default.resolve('node_modules/ink-remote/public/index.css')))
        .get('/normalize.css', (req, res) => res.sendFile(app_root_path_1.default.resolve('node_modules/ink-remote/public/normalize.css')))
        .get('/node_modules/xterm/lib/xterm.js', (req, res) => res.sendFile(app_root_path_1.default.resolve('node_modules/xterm/lib/xterm.js')))
        .get('/node_modules/xterm-addon-fit/lib/xterm-addon-fit.js', (req, res) => res.sendFile(app_root_path_1.default.resolve('node_modules/xterm-addon-fit/lib/xterm-addon-fit.js')))
        .get('/', (e, res) => res
        .status(200)
        .send(handlebars.compile(fs_1.default.readFileSync(app_root_path_1.default.resolve('node_modules/ink-remote/public/index.html'), 'utf-8'))({
        address: ip_1.default.address(),
        port,
    }))));
    // Receive messages from the client.
    app.ws('/', (ws, req) => ws.on('message', (msg) => undefined));
    app.listen(port);
    return getWss();
};
exports.serve = serve;
